// Tesina di Linguaggi e Traduttori
// Scanner di log del server apache
// Alberto Realis-Luc    Mat.142119
// Leandro Dipietro      Mat.134841

public class DataOra {
	private int gg;
	private int mm;
	private int aaaa;
	private int ora;
	private int min;
	private int sec;
	private static final String[] mesi={"Gen","Feb","Mar","Apr","Mag","Giu","Lug","Ago","Set","Ott","Nov","Dic"};
	private static final String[] months={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
	
	public DataOra (int gg, String mm, int aaaa, int ora, int min, int sec) {
		this.gg=gg;
		boolean trovato=false;
		int i;
		for(i=0;i<12 && !trovato;i++)
			if(mm.compareTo(mesi[i])==0) {
				this.mm=i;
				trovato=true;
			}
		if(!trovato) for(i=0;i<12 && !trovato;i++)
			if(mm.compareTo(months[i])==0) {
				this.mm=i;
				trovato=true;
			}
		this.aaaa=aaaa;
		this.ora=ora;
		this.min=min;
		this.sec=sec;
	}
	
	public DataOra (int gg, int mm, int aaaa, int ora, int min, int sec) {
		this.gg=gg;
		this.mm=mm-1;
		this.aaaa=aaaa;
		this.ora=ora;
		this.min=min;
		this.sec=sec;
	}
	
	public String toString() {
		return gg+"/"+mesi[mm]+"/"+aaaa+" "+ora+":"+min+":"+sec;
	}
	
	public boolean isEqual(DataOra dataOra) {
		if(this.gg==dataOra.gg &&
				this.mm==dataOra.mm &&
				this.aaaa==dataOra.aaaa &&
				this.ora==dataOra.ora &&
				this.min==dataOra.min &&
				this.sec==dataOra.sec) return true;
		else return false;
	}
	
	public boolean isPast(DataOra dataOra) {
		if(this.aaaa<dataOra.aaaa) return true; //controllo sull'anno
		else if(this.aaaa==dataOra.aaaa)
			if(this.mm<dataOra.mm) return true; //controllo sul mese
			else if(this.mm==dataOra.mm)
				if(this.gg<dataOra.gg) return true; //controllo sul giorno
				else if(this.gg==dataOra.gg)
					if(this.ora<dataOra.ora) return true; //controllo sull'ora 
					else if(this.ora==dataOra.ora)
						if(this.min<dataOra.min) return true; //controllo sul minuto
						else if(this.min==dataOra.min && this.sec<=dataOra.sec) return true; //controllo sul secondo
		return false;
	}

	public boolean isFuture(DataOra dataOra) {
		if(this.aaaa>dataOra.aaaa) return true; //controllo sull'anno
		else if(this.aaaa==dataOra.aaaa)
			if(this.mm>dataOra.mm) return true; //controllo sul mese
			else if(this.mm==dataOra.mm)
					if(this.gg>dataOra.gg) return true; //controllo sul giorno
					else if(this.gg==dataOra.gg)
						if(this.ora>dataOra.ora) return true; //controllo sull'ora 
						else if(this.ora==dataOra.ora)
							if(this.min>dataOra.min) return true; //controllo sul minuto
							else if(this.min==dataOra.min && this.sec>=dataOra.sec) return true; //controllo sul secondo
		return false;
	}
	
	public boolean isBetween(DataOra dataOraIniz, DataOra dataOraFine) {
		if(this.isFuture(dataOraIniz) && this.isPast(dataOraFine)) return true;
		else return false;
	}

}