// Tesina di Linguaggi e Traduttori
// Scanner di log del server apache
// Alberto Realis-Luc    Mat.142119
// Leandro Dipietro      Mat.134841

public class Accesso { //classe che descrive ogni accesso
	public Ip ip;
	public String utenteRemoto;
	public String utente;
	public DataOra dataOra;
	public String richiesta;
	public int status;
	public int bytes;
	public String refer;
	public String useragent;

	public Accesso(Ip ip, String utenteRemoto, String utente, DataOra dataOra, String richiesta, int status, int bytes, String refer, String useragent) {
		this.ip=ip;
		this.utenteRemoto=utenteRemoto;
		this.utente=utente;
		this.dataOra=dataOra;
		this.richiesta=richiesta;
		this.status=status;
		this.bytes=bytes;
		this.refer=refer;
		this.useragent=useragent;
	}
	
	public String toString() {
		return "IP: "+ip.toString()+
		" Utente remoto: "+utenteRemoto+
		" Utente: "+utente+
		" Tempo: "+dataOra.toString()+
		" Richiesta: "+richiesta+
		" HTTP Status code: "+status+
		" Dimensione file (Bytes): "+bytes+
		" Refer :"+refer+
		" Useragent :"+useragent;
	}
	
	public String toHtml() {
		return "<tr><td>"+ip.toString()+"</td>"+
		"<td>"+utenteRemoto+"</td>"+
		"<td>"+utente+"</td>"+
		"<td>"+dataOra.toString()+"</td>"+
		"<td>"+richiesta+"</td>"+
		"<td>"+status+"</td>"+
		"<td>"+bytes+"</td>"+
		"<td>"+refer+"</td>"+
		"<td>"+useragent+"</td></tr>\n";
	}	
}